#!/bin/bash

all_refs=$(grep -ho '\[[^]]*\]\[[^]]*\]' pages/*.markdown|perl -pe 's/.*\[(.*)\]$/$1/'|sort|uniq)

known_refs=$(grep '^\[.*\]' markdown.references|perl -pe 's/^\[(.*?)\].*/$1/')

all_ptrn=$(tr <<<"$all_refs" '\n' '|')
known_ptrn=$(tr <<<"$known_refs" '\n' '|')

all_ptrn="${all_ptrn:0:${#all_ptrn}-1}"
known_ptrn="${known_ptrn:0:${#known_ptrn}-1}"

echo -e "Missing:\n"
grep -Ev <<<"$all_refs" "^($known_ptrn)$"|perl -pe 's/.*/[$&]: MISSING/'|tee -a markdown.references

echo -e "\nRedundant:\n"
grep -Ev <<<"$known_refs" "^($all_ptrn)$"
